import java.io.*;
import java.util.*;
import java.util.regex.*;

        class ZR2PS
        {
                YYARec[] yya;
                YYARec[] yyg;
                YYRRec[] yyr;
                int[] yyd;
                int[] yyal;
                int[] yyah;
                int[] yygl;
                int[] yygh;

                int yyn = 0;
                int yystate = 0;
                int yychar = -1;
                int yynerrs = 0;
                int yyerrflag = 0;
                int yysp = 0;
                int yymaxdepth = 1024;
                int yyflag = 0;
                int yyfnone   = 0;
                int[] yys = new int[1024];
                String[] yyv = new String[1024];

                String yyval = "";

                public static class TOutput extends PrintWriter { 
                 public TOutput(BufferedWriter b) { super(b); }
                 public TOutput(PrintStream s) { super(s); }
                 public void WriteLine(String s) { println(s); } 
                }
                TOutput Output;

                class YYARec
                {
                        public int sym;
                        public int act;
                        public YYARec (int s, int a){ sym = s; act = a; }
                }

                class YYRRec
                {
                        public int len;
                        public int sym;
                        public YYRRec (int l, int s){ sym = s; len = l; }
                }

                ////////////////////////////////////////////////////////////////
                /// Constant values / tokens
                ////////////////////////////////////////////////////////////////
                int t_zahl = 257;
                int t_KlammerAuf = 258;
                int t_KlammerZu = 259;
                int t_farbwert = 260;
                int t_VW = 261;
                int t_RE = 262;
                int t_WH = 263;
                int t_FARBE = 264;
                int t_STIFT = 265;
                int t_ignore = 256;
///////////////////////////////////////////////////////////
/// Global settings: 
///////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////


                /// <summary>
                /// Der Haupteinstiegspunkt fr die Anwendung.
                /// </summary>
                public static void main(String[] args)
                {
                        ZR2PS compiler = new ZR2PS();
                        String inputstream = "";

                        boolean ShowTokens = false;
                        String InputFilename = "";
                        String OutputFilename = "";

                        for (String s : args)
                        {
                                if (s.toLowerCase().equals("-t"))
                                {
                                        ShowTokens = true;
                                }
                                else
                                {
                                        if (InputFilename.equals(""))  InputFilename = s; else
                                        if (OutputFilename.equals("")) OutputFilename = s; else
                                        {
                                                System.out.println("Too many arguments!");
                                                System.exit(1);
                                        }
                                }
                        }
                        if (InputFilename.equals(""))
                        {
                                System.out.println("You need to specify input and outputfile: compiler.exe input.txt output.txt");
                                System.exit(1);
                        }

                        try{

						FileInputStream in=new FileInputStream(InputFilename);
						int len=in.available();
						for(int i=1;i<=len;i++)
						{
						   inputstream += (char)in.read();
						}
                        in.close();

                        ////////////////////////////////////////////////////////////////
                        /// Compiler Code:
                        ////////////////////////////////////////////////////////////////

			

                        compiler.Output = null;
                        if (!OutputFilename.equals(""))
                        {
                                File myFile = new File(OutputFilename);
                                myFile.delete();
                                compiler.Output = new TOutput(new BufferedWriter(new FileWriter(OutputFilename)));
                        }
                        else
                        {
                                compiler.Output = new TOutput(System.out);
                        }
                        }catch (Exception e) {e.printStackTrace(); System.exit(1);}

                        if (!compiler.Scanner(inputstream)) System.exit(1);
                        if (ShowTokens)
                        {
                                for (Object o : compiler.TokenList)
                                {
                                        AToken t = (AToken)o;
                                        System.out.println("TokenID: "+t.token+"  =  "+t.val);
                                }
                        }
                        compiler.InitTables();
                        if(!compiler.yyparse()) System.exit(1);

                        if (compiler.Output != null) compiler.Output.close();			
                }
                public void yyaction (int yyruleno)
                {
                        switch (yyruleno)
                        {
                                ////////////////////////////////////////////////////////////////
                                /// YYAction code:
                                ////////////////////////////////////////////////////////////////
							case    1 : 
         String s = "";
         s += "%!PS-Adobe-2.0 \r\n";
         s += "/orient 0 def /xpos 0 def /ypos 0 def \r\n";
         s += "0 0 0 setrgbcolor\r\n"; // Stiftfarbe
         s += "/goto { /ypos exch def /xpos exch def xpos ypos moveto} def\r\n";
         s += "/turn { /orient exch orient add def} def \r\n";
         s += "/draw { /len exch def newpath xpos ypos moveto \r\n";
         s += "   /xpos xpos orient sin len mul add def \r\n";
         s += "   /ypos ypos orient cos len mul add def \r\n";
         s += "   xpos ypos lineto stroke \r\n";
         s += "} def \r\n";
         s += "300 400 goto\r\n"; // in Blattmitte beginnen
         
         s += yyv[yysp-0]+"\r\n"; // Die synthetisierten Inhalte in yyv[yysp-0] anfgen   
         
         Output.WriteLine(s);
         
       break;
							case    2 : 
         yyval = yyv[yysp-0];
         
       break;
							case    3 : 
         yyval = yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case    4 : 
         yyval = yyv[yysp-0]+" draw ";
         
       break;
							case    5 : 
         yyval = yyv[yysp-0]+" turn ";
         
       break;
							case    6 : 
         yyval = "";
         for (int i = 0; i < Integer.parseInt(yyv[yysp-3]); i++) yyval += yyv[yysp-1];
         
       break;
							case    7 : 
         if (yyv[yysp-0].equals("blau"))    yyval = "0 0 255 setrgbcolor ";
         if (yyv[yysp-0].equals("rot"))     yyval = "255 0 0 setrgbcolor ";
         if (yyv[yysp-0].equals("gruen"))   yyval = "0 255 0 setrgbcolor ";
         if (yyv[yysp-0].equals("gelb"))    yyval = "255 255 0 setrgbcolor ";
         if (yyv[yysp-0].equals("schwarz")) yyval = "0 0 0 setrgbcolor ";
         
       break;
							case    8 : 
         yyval = yyv[yysp-0]+" setlinewidth ";
         
       break;
                                default : return;
                        }
                }

                public void InitTables()
                {
                        ////////////////////////////////////////////////////////////////
                        /// Init Table code:
                        ////////////////////////////////////////////////////////////////

					int yynacts   = 25;
					int yyngotos  = 7;
					int yynstates = 18;
					int yynrules  = 8;
					yya = new YYARec[yynacts+1];  int yyac = 1;
					yyg = new YYARec[yyngotos+1]; int yygc = 1;
					yyr = new YYRRec[yynrules+1]; int yyrc = 1;

					yya[yyac] = new YYARec(261,4);yyac++; 
					yya[yyac] = new YYARec(262,5);yyac++; 
					yya[yyac] = new YYARec(263,6);yyac++; 
					yya[yyac] = new YYARec(264,7);yyac++; 
					yya[yyac] = new YYARec(265,8);yyac++; 
					yya[yyac] = new YYARec(261,4);yyac++; 
					yya[yyac] = new YYARec(262,5);yyac++; 
					yya[yyac] = new YYARec(263,6);yyac++; 
					yya[yyac] = new YYARec(264,7);yyac++; 
					yya[yyac] = new YYARec(265,8);yyac++; 
					yya[yyac] = new YYARec(0,-2 );yyac++; 
					yya[yyac] = new YYARec(259,-2 );yyac++; 
					yya[yyac] = new YYARec(0,0);yyac++; 
					yya[yyac] = new YYARec(257,10);yyac++; 
					yya[yyac] = new YYARec(257,11);yyac++; 
					yya[yyac] = new YYARec(257,12);yyac++; 
					yya[yyac] = new YYARec(260,13);yyac++; 
					yya[yyac] = new YYARec(257,14);yyac++; 
					yya[yyac] = new YYARec(258,15);yyac++; 
					yya[yyac] = new YYARec(261,4);yyac++; 
					yya[yyac] = new YYARec(262,5);yyac++; 
					yya[yyac] = new YYARec(263,6);yyac++; 
					yya[yyac] = new YYARec(264,7);yyac++; 
					yya[yyac] = new YYARec(265,8);yyac++; 
					yya[yyac] = new YYARec(259,17);yyac++;

					yyg[yygc] = new YYARec(-4,1);yygc++; 
					yyg[yygc] = new YYARec(-3,2);yygc++; 
					yyg[yygc] = new YYARec(-2,3);yygc++; 
					yyg[yygc] = new YYARec(-4,1);yygc++; 
					yyg[yygc] = new YYARec(-3,9);yygc++; 
					yyg[yygc] = new YYARec(-4,1);yygc++; 
					yyg[yygc] = new YYARec(-3,16);yygc++;

					yyd = new int[yynstates];
					yyd[0] = 0;  
					yyd[1] = 0;  
					yyd[2] = -1;  
					yyd[3] = 0;  
					yyd[4] = 0;  
					yyd[5] = 0;  
					yyd[6] = 0;  
					yyd[7] = 0;  
					yyd[8] = 0;  
					yyd[9] = -3;  
					yyd[10] = -4;  
					yyd[11] = -5;  
					yyd[12] = 0;  
					yyd[13] = -7;  
					yyd[14] = -8;  
					yyd[15] = 0;  
					yyd[16] = 0;  
					yyd[17] = -6; 

					yyal = new int[yynstates];
					yyal[0] = 1;  
					yyal[1] = 6;  
					yyal[2] = 13;  
					yyal[3] = 13;  
					yyal[4] = 14;  
					yyal[5] = 15;  
					yyal[6] = 16;  
					yyal[7] = 17;  
					yyal[8] = 18;  
					yyal[9] = 19;  
					yyal[10] = 19;  
					yyal[11] = 19;  
					yyal[12] = 19;  
					yyal[13] = 20;  
					yyal[14] = 20;  
					yyal[15] = 20;  
					yyal[16] = 25;  
					yyal[17] = 26; 

					yyah = new int[yynstates];
					yyah[0] = 5;  
					yyah[1] = 12;  
					yyah[2] = 12;  
					yyah[3] = 13;  
					yyah[4] = 14;  
					yyah[5] = 15;  
					yyah[6] = 16;  
					yyah[7] = 17;  
					yyah[8] = 18;  
					yyah[9] = 18;  
					yyah[10] = 18;  
					yyah[11] = 18;  
					yyah[12] = 19;  
					yyah[13] = 19;  
					yyah[14] = 19;  
					yyah[15] = 24;  
					yyah[16] = 25;  
					yyah[17] = 25; 

					yygl = new int[yynstates];
					yygl[0] = 1;  
					yygl[1] = 4;  
					yygl[2] = 6;  
					yygl[3] = 6;  
					yygl[4] = 6;  
					yygl[5] = 6;  
					yygl[6] = 6;  
					yygl[7] = 6;  
					yygl[8] = 6;  
					yygl[9] = 6;  
					yygl[10] = 6;  
					yygl[11] = 6;  
					yygl[12] = 6;  
					yygl[13] = 6;  
					yygl[14] = 6;  
					yygl[15] = 6;  
					yygl[16] = 8;  
					yygl[17] = 8; 

					yygh = new int[yynstates];
					yygh[0] = 3;  
					yygh[1] = 5;  
					yygh[2] = 5;  
					yygh[3] = 5;  
					yygh[4] = 5;  
					yygh[5] = 5;  
					yygh[6] = 5;  
					yygh[7] = 5;  
					yygh[8] = 5;  
					yygh[9] = 5;  
					yygh[10] = 5;  
					yygh[11] = 5;  
					yygh[12] = 5;  
					yygh[13] = 5;  
					yygh[14] = 5;  
					yygh[15] = 7;  
					yygh[16] = 7;  
					yygh[17] = 7; 

					yyr[yyrc] = new YYRRec(1,-2);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-3);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-3);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(5,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-4);yyrc++;
                }

                public boolean yyact(int state, int sym)
                {
                        int k = yyal[state];
                        while ( k <= yyah[state] && yya[k].sym != sym) k++;
                        if (k > yyah[state]) return false;
                        yyn = yya[k].act;
                        return true;
                }
                public boolean yygoto(int state, int sym)
                {
                        int k = yygl[state];
                        while ( k <= yygh[state] && yyg[k].sym != sym) k++;
                        if (k > yygh[state]) return false;
                        yyn = yyg[k].act;
                        return true;
                }

                public void yyerror (String s)
                {
                        System.out.println(s);
                }

                int yylexpos = -1;
                String yylval = "";

                public int yylex ()
                {
                        yylexpos++;
                        if(yylexpos >= TokenList.size())
                        {
                                yylval = "";
                                return 0;
                        }
                        else
                        {
                                yylval = ((AToken)TokenList.get(yylexpos)).val;
                                return ((AToken)TokenList.get(yylexpos)).token;
                        }
                }


                public boolean yyparse ()
                {
                        boolean jumpToNext = false;
                        while(true){ // Parse:
                        if (!jumpToNext){
                        yysp++;
                        if (yysp>yymaxdepth)
                        {
                                yyerror("yyparse stack overflow");
                                return false;
                        }

                        yys[yysp] = yystate;
                        yyv[yysp] = yyval;
                        }
                        jumpToNext = false;

                        if (yyd[yystate]==0 && yychar==-1)
                        {
                            yychar = yylex();
                            if (yychar<0) yychar = 0;
                        }

                        yyn = yyd[yystate];
                        if (yyn != 0) {
                         /// reduce:
                         yyflag = yyfnone;
                         yyaction(-yyn);
                         yysp -= yyr[-yyn].len;
                         if (yygoto(yys[yysp], yyr[-yyn].sym)) yystate = yyn;
                         switch (yyflag)
                         {
                                 case 1 : return true;
                                 case 2 : return false;
                                 case 3 : {
                                   int r = yy_errlab();
                                   if (r == 0) return false;
                                   if (r == 1) continue;
                                   if (r == 2) {jumpToNext = true; continue; }
                                 }
                         }
                         continue; // PARSE:
                         ///////////////
                        }

                        if (! yyact(yystate, yychar)) {
                          if (yyerrflag==0) yyerror("syntax error");
                          int r = yy_errlab();
                          if (r == 0) return false;
                          if (r == 1) continue;
                          if (r == 2) {jumpToNext = true; continue; }
                        }
                        else if (yyn>0) {
                         /// shift:
                         yystate = yyn;
                         yychar = -1;
                         yyval = yylval;
                         if (yyerrflag>0) yyerrflag--;
                         continue; // PARSE:
                         ///////////////
                        }
                        else if (yyn<0) {
                         /// reduce:
                         yyflag = yyfnone;
                         yyaction(-yyn);
                         yysp -= yyr[-yyn].len;
                         if (yygoto(yys[yysp], yyr[-yyn].sym)) yystate = yyn;
                         switch (yyflag)
                         {
                                 case 1 : return true;
                                 case 2 : return false;
                                 case 3 : {
                                   int r = yy_errlab();
                                   if (r == 0) return false;
                                   if (r == 1) continue;
                                   if (r == 2) {jumpToNext = true; continue; }
                                 }
                         }
                         continue; // PARSE:
                         ///////////////
                        }
                        else return true;
                        } // WHILE Parse:
                }

                public int yy_errlab (){
                        if (yyerrflag==0) yynerrs++;
                        if (yyerrflag<=2)
                        {
                                yyerrflag = 3;
                                while (yysp>0 && !(yyact(yys[yysp], 255) && yyn > 0)) yysp--;

                                if (yysp==0) return 0;
                                yystate = yyn;
                                return 1; // PARSE:
                        }
                        else
                        {
                                if (yychar==0) return 0;
                                yychar = -1;
                                return 2;
                        }
                }
		////////////////////////////////////////////////////////////////
		/// Scanner
		////////////////////////////////////////////////////////////////

		public class AToken
		{
			public int token;
			public String val;
		}

		ArrayList<AToken> TokenList = new ArrayList<AToken>();

		public boolean Scanner (String Input)
		{
		        if (Input.length() == 0) return true;
			TokenList = new ArrayList<AToken>();
			while (1==1)
			{
				AToken lasttoken = FindToken(Input);
				if (lasttoken.token == 0) break;
				if (lasttoken.token != t_ignore) TokenList.add(lasttoken);
				if (Input.length() > lasttoken.val.length())
				Input = Input.substring(lasttoken.val.length()); else return true;
			}
                      System.out.println(Input);
			System.out.println();
			System.out.println("No matching token found!");
			return false;
		}
		public AToken FindToken (String Rest)
		{
			ArrayList<Integer> Results  = new ArrayList<Integer>();
			ArrayList<String> ResultsV = new ArrayList<String>();
                      try{

                        Pattern p;
                        Matcher m;
                      p = Pattern.compile("^([1-9][0-9]*)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_zahl));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\[)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_KlammerAuf));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\])");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_KlammerZu));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(rot|blau|gruen|gelb|schwarz)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_farbwert));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(VW)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_VW));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(RE)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_RE));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(WH)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_WH));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(FARBE)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_FARBE));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(STIFT)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_STIFT));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^([\\r\\s\\t\\n])");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_ignore));
				ResultsV.add(m.group());}

			} catch (Exception e) {}
			int maxlength = 0;
			int besttoken = 0;
			AToken ret = new AToken();
		        ret.token = besttoken;
			for (int i = 0; i < Results.size(); i++){
				if (ResultsV.get(i).toString().length() > maxlength)
				{
					maxlength = ResultsV.get(i).toString().length();
					besttoken = ((Integer)Results.get(i)).intValue();
		         	        ret.token = besttoken;
		                  	if (besttoken != 0)
			                ret.val   = ResultsV.get(i).toString();
				}
			}
			return ret;
		}


	}
